function [ newParticles, newWeights ] = pf_resample2( particles, weights )
%PF_RESAMPLE2 Summary of this function goes here
% Given the current particles and weights, sample new particles and weights
% Use the low variance sampler from class.
% INPUTS:
%  particles    - particles, Nx1 vector
%  weights      - importance weights, Nx1 vector
% 
% OUTPUTS:
% newParticles  - resampled particles, Nx1
% newWeights    - updated weights for the particles, Nx1


% Low variance sampler

N = length(particles);
newParticles = cell(N,1);

u = rand / N;
curWeightSum = weights(1);
i = 1;

for j = 1:N
    
    while u > curWeightSum
        i = mod(i, N) + 1;
        curWeightSum = curWeightSum + weights(i);
    end

    newParticles{j} = particles{i};
    u = u + 1/N;
end

newWeights = ones(N,1)*(1/N);